C===================================================================
C
      PROGRAM RECT2
C
C  This program creates the INPUTFILE for LABECON when the 
C  domain is multiply connected (rectangular boundaries) 
C    
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*15 INPUTFILE 
      CHARACTER*80 NAME,TITLE
      PARAMETER (N=24)
      PARAMETER (IN=8)
	PARAMETER (NB=2)
      DIMENSION XL(N+1),YL(N+1),XIN(IN),YIN(IN)
      DIMENSION KCODE(N),UB(N),NL(NB)
C      
      WRITE (*,'(A)')' Name of the INPUTFILE (max.15 characters)'
      READ  (*,'(A)') INPUTFILE
      OPEN (1, FILE=INPUTFILE)
      WRITE (*,'(A)')' User NAME (max.15 characters)'
      READ(*,'(A)')NAME
      WRITE(1,'(A)')NAME
      WRITE (*,'(A)')' Program TITLE (max.15 characters)' 
      READ(*,'(A)')TITLE
      WRITE(1,'(A)')TITLE
C      
      WRITE(1,100)
  100 FORMAT(' ',79(' '))
C
  	NL(1)=16
	NL(2)=24
	WRITE(1,250)(NL(I),I=1,NB)
  250	FORMAT(I4)
C
C  Boundary coordinates  
C
	DO 111 K=1,NB

	IF (K.EQ.1) THEN
      AA=1.
      BB=1.
      NX=4
      NY=4

      DA=AA/NX
      DB=BB/NY
      DO 1 I=1,NX      
      XL(I)=(I-1)*DA
      YL(I)=0.      
    1 WRITE(1,300)XL(I),YL(I)
  300 FORMAT(2(2X,F14.8))
C     
      DO 2 I=1,NY      
      XL(I+NX)=AA
      YL(I+NX)=(I-1)*DB
    2 WRITE(1,300)XL(I+NX),YL(I+NX)
C    
      DO 3 I=1,NX      
      XL(I+NX+NY)=AA-(I-1)*DA
      YL(I+NX+NY)=BB      
    3 WRITE(1,300)XL(I+NX+NY),YL(I+NX+NY) 
C    
      DO 4 I=1,NY      
      XL(I+NX+NY+NX)=0.
      YL(I+NX+NY+NX)=BB-(I-1)*DB
    4 WRITE(1,300)XL(I+NX+NY+NX),YL(I+NX+NY+NX)

	ELSE

	AA=0.4
	BB=0.4
	NX=2
	NY=2
      DA=AA/NX
      DB=BB/NY
      DO 6 J=1,NY
	I=J+NL(1)      
	XL(I)=.3
	YL(I)=0.3+(J-1)*DB
    6 WRITE(1,300)XL(I),YL(I)
C     
      DO 7 J=1,NX
	I=J+NL(1)      
	XL(I+NY)=.3+(J-1)*DA
	YL(I+NY)=BB+0.3
    7 WRITE(1,300) XL(I+NY),YL(I+NY)
C    
      DO 8 J=1,NY      
	I=J+NL(1)      
	XL(I+NX+NY)=0.3+AA
	YL(I+NX+NY)=0.3+BB-(J-1)*DB
    8 WRITE(1,300)XL(I+NX+NY),YL(I+NX+NY) 
C    
      DO 9 J=1,NX
	I=J+NL(1)      
      XL(I+NY+NX+NY)=0.3+AA-(J-1)*DA
      YL(I+NY+NX+NY)=0.3
    9 WRITE(1,300)XL(I+NY+NX+NY),YL(I+NY+NX+NY)
	ENDIF
C      
  111	CONTINUE

	WRITE (1,100)
C
C Boundary conditions  
C
	DO 112 K=1,NB
	IF (K.EQ.1) THEN
      NX=4
      NY=4
	NF=1 

      XL(NL(1)+1)=XL(NF)
      YL(NL(1)+1)=YL(NF)

      DO 10 I=1,NX
      KCODE(I)=1
   10 UB(I)=0.0
      DO 20 I=1,NY
	II=I+NX
      KCODE(II)=0
   20 UB(II)=200.
      DO 30 I=1,NX
	II=I+NX+NY
      KCODE(II)=1
   30 UB(II)=0.
      DO 40 I=1,NY
	II=I+NX+NY+NX
      KCODE(II)=0
   40 UB(II)=100.

	ELSE
	NX=2
	NY=2
	NF=NL(1)+1

      XL(NL(2)+1)=XL(NF)
      YL(NL(2)+1)=YL(NF)

      DO 11 J=1,NY
	I=J+NL(1)
      KCODE(I)=0
   11 UB(I)=130.
      DO 21 J=1,NX
	I=J+NL(1)
	II=I+NX
      KCODE(II)=1
   21 UB(II)=0.0
      DO 31 J=1,NY
	I=J+NL(1)
	II=I+NX+NY
      KCODE(II)=1
   31 UB(II)=-100.
      DO 41 J=1,NX
	I=J+NL(1)
	II=I+NX+NY+NX
      KCODE(II)=1
   41 UB(II)=0.
	ENDIF
  112	CONTINUE
C
      DO 50 I=1,N
   50 WRITE(1,400) KCODE(I),UB(I)
  400 FORMAT(I4,3X,2(F20.8))

C      
      WRITE(1,100)
C
C     Coordinates of the internal points
C
      IX=3
      JY=3
      DX=0.35
      DY=0.35
	K=1
      WRITE(1,100)     
C
      DO 5 J=1,JY 
      DO 5 I=1,IX       
      XIN(K)=0.15+(I-1)*DX
      YIN(K)=0.15+(J-1)*DY
      IF(ABS(XIN(K)-0.5).LT.0.2 .AND. ABS(YIN(K)-0.5).LT.0.2) GOTO 5
	WRITE(1,300)XIN(K),YIN(K)
      K=K+1
    5 CONTINUE    
C      
      WRITE(1,100)
C    
      STOP
      END 
C
C===================================================================       